    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * --------------------------
    028     * DatasetRenderingOrder.java
    029     * --------------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 02-May-2003 : Version 1 (DG);
    038     * 02-Jun-2004 : Changed 'STANDARD' --> 'FORWARD' (DG);
    039     * 21-Nov-2007 : Implemented hashCode() (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.plot;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Defines the tokens that indicate the rendering order for datasets in a
    050     * {@link org.jfree.chart.plot.CategoryPlot} or an
    051     * {@link org.jfree.chart.plot.XYPlot}.
    052     */
    053    public final class DatasetRenderingOrder implements Serializable {
    054
    055        /** For serialization. */
    056        private static final long serialVersionUID = -600593412366385072L;
    057
    058        /**
    059         * Render datasets in the order 0, 1, 2, ..., N-1, where N is the number
    060         * of datasets.
    061         */
    062        public static final DatasetRenderingOrder FORWARD
    063                = new DatasetRenderingOrder("DatasetRenderingOrder.FORWARD");
    064
    065        /**
    066         * Render datasets in the order N-1, N-2, ..., 2, 1, 0, where N is the
    067         * number of datasets.
    068         */
    069        public static final DatasetRenderingOrder REVERSE
    070                = new DatasetRenderingOrder("DatasetRenderingOrder.REVERSE");
    071
    072        /** The name. */
    073        private String name;
    074
    075        /**
    076         * Private constructor.
    077         *
    078         * @param name  the name.
    079         */
    080        private DatasetRenderingOrder(String name) {
    081            this.name = name;
    082        }
    083
    084        /**
    085         * Returns a string representing the object.
    086         *
    087         * @return The string (never <code>null</code>).
    088         */
    089        public String toString() {
    090            return this.name;
    091        }
    092
    093        /**
    094         * Returns <code>true</code> if this object is equal to the specified
    095         * object, and <code>false</code> otherwise.
    096         *
    097         * @param obj  the object (<code>null</code> permitted).
    098         *
    099         * @return A boolean.
    100         */
    101        public boolean equals(Object obj) {
    102            if (this == obj) {
    103                return true;
    104            }
    105            if (!(obj instanceof DatasetRenderingOrder)) {
    106                return false;
    107            }
    108            DatasetRenderingOrder order = (DatasetRenderingOrder) obj;
    109            if (!this.name.equals(order.toString())) {
    110                return false;
    111            }
    112            return true;
    113        }
    114
    115        /**
    116         * Returns a hash code for this instance.
    117         *
    118         * @return A hash code.
    119         */
    120        public int hashCode() {
    121            return this.name.hashCode();
    122        }
    123
    124        /**
    125         * Ensures that serialization returns the unique instances.
    126         *
    127         * @return The object.
    128         *
    129         * @throws ObjectStreamException if there is a problem.
    130         */
    131        private Object readResolve() throws ObjectStreamException {
    132            if (this.equals(DatasetRenderingOrder.FORWARD)) {
    133                return DatasetRenderingOrder.FORWARD;
    134            }
    135            else if (this.equals(DatasetRenderingOrder.REVERSE)) {
    136                return DatasetRenderingOrder.REVERSE;
    137            }
    138            return null;
    139        }
    140
    141    }